package com.ruoyi.project.business.service;


import cn.hutool.core.lang.tree.Tree;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.project.business.domain.TbAgent;
import com.ruoyi.project.system.domain.SysUser;

import java.util.List;

/**
 * 【请填写功能名称】Service接口
 * 
 * @author ruoyi
 * @date 2024-04-16
 */
public interface ITbAgentService extends IService<TbAgent>
{
    /**
     * 查询【请填写功能名称】
     * 
     * @param agentId 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    // public TbAgent selectTbAgentByAgentId(Long agentId);

    /**
     * 查询【请填写功能名称】列表
     * 
     * @param tbAgent 【请填写功能名称】
     * @return 【请填写功能名称】集合
     */
    public List<TbAgent> selectTbAgentList(TbAgent tbAgent);

    /**
     * 新增【请填写功能名称】
     *
     * @param tbAgent 【请填写功能名称】
     * @return 结果
     */
    public boolean insertTbAgent(TbAgent tbAgent);

    /**
     * 修改【请填写功能名称】
     *
     * @param tbAgent 【请填写功能名称】
     * @return 结果
     */
    public boolean updateTbAgent(TbAgent tbAgent);

    /**
     * 批量删除【请填写功能名称】
     *
     * @param agentIds 需要删除的【请填写功能名称】主键集合
     * @return 结果
     */
    public boolean deleteTbAgentByAgentIds(Long[] agentIds);

    /**
     * 删除【请填写功能名称】信息
     * 
     * @param agentId 【请填写功能名称】主键
     * @return 结果
     */
    public int deleteTbAgentByAgentId(Long agentId);

    //List<TreeSelect> selectAgentTreeList(TbAgent agent);

    /**
     * 查询代理商树列表
     * @param agent 查询条件
     */
    List<Tree<Long>> selectAgentTreeList(TbAgent agent);

    List<TbAgent> selectAgentByAreaId(Long areaId, Long agentId);

    /**
     * 所属区域的销售经理角色的user
     *
     * @param areaId 区域id
     */
    List<SysUser> selectSaleByAreaId(Long areaId);

    int changeStatus(TbAgent agent);

    /**
     * 获取客户全部代理商
     */
    List<TbAgent> selectForAccount();

    List<TbAgent> selectForProject();
    List<TbAgent> selectForYear(String yearParam);

    List<TbAgent> selectChildAreaList(Long agentId, boolean justSubs, boolean includeSelf);

    List<TbAgent> selectAgentListByOwner(Long ownerId);

    TbAgent getInfo(Long agentId);
}
